#pragma once
#include <iostream>
#include "exception.h"
#include <time.h>
#include "Vector.h"
class Vector;
class CSLRMatrix {

private:

    double* m_adiag;
    double* m_altr;
    size_t* m_jptr;
    size_t* m_iptr;
    size_t m_diag;
    size_t m_elem;
    friend class Vector;
public:

    CSLRMatrix(double* p_adiag, double* p_altr, size_t* p_jptr, size_t* p_iptr, size_t p_diag, size_t p_elem);
    CSLRMatrix(const CSLRMatrix& p_mat);
    ~CSLRMatrix();


    friend std::istream& operator>>(std::istream& is, CSLRMatrix& p_mat);
    friend std::ostream& operator<<(std::ostream& os, const CSLRMatrix& p_mat);

    size_t matsize() const;
    size_t nzn() const;

    const CSLRMatrix& operator=(const CSLRMatrix& p_mat);

    friend Vector operator*(const CSLRMatrix& p_mat, const Vector& p_vec);
    friend CSLRMatrix operator*(double scalar, const CSLRMatrix& p_mat);
    friend CSLRMatrix operator*(const CSLRMatrix& p_mat, double scalar);

};
